Subject: Re: Ethernet not working on a different SoC with same eth HW

From: Andrew Lunn <[email-masked]>
Date: Fri, 4 Nov 2016 16:17:44 +0100

On Fri, Nov 04, 2016 at 03:05:00PM +0000, Måns Rullgård wrote:
> Andrew Lunn <[email-masked]> writes:
> 
> >> > I agree with you. But fixing it is likely to break boards which
> >> > currently have "rgmii", but actually need the delay in order to work.
> >> 
> >> Does the internal delay here refer to the PHY or the MAC?  It's a
> >> property of the MAC node after all.
> >
> > It is the PHY which applies the delay.
> 
> Says who?

The source code.

>  Some MACs can do it too.

I'm sure they can. But look at the code. Nearly none do, and those
that do are potentially broken.
 
> There is also no way to specify the amount of delay required even though
> many devices support more than one value.

Those PHYs that which support variable delays add there own device
tree properties. See for example Micrel KSZ9021/KSZ9031 Gigabit Ethernet PHY

     Andrew